/**
*
* PROJET SIANA // (c) 2016 ATHK
*
*/

import ddf.minim.analysis.*;
import ddf.minim.*;

Minim minim;  
AudioPlayer jingle;
FFT fftLin;
FFT fftLog;
float lum;
float lumTarget;
float volume;
int bufferSize = 1024;

float spectrumScale = 500;

float[] radius = new float[bufferSize / 2];
float[] radiusTarget = new float[bufferSize / 2];

void setup()
{
  size(displayWidth, displayHeight, OPENGL);
//  size(800, 600, OPENGL);

  minim = new Minim(this);
  jingle = minim.loadFile("2-Ganzfeld.mp3", bufferSize);
  
  // loop the file
  jingle.loop();
  
  fftLin = new FFT( jingle.bufferSize(), jingle.sampleRate() );
  
  fftLin.linAverages( 30 );
}

void draw()
{
  colorMode(RGB);
  
  noStroke();
  
  fill(0, 50);
  
  rect(0, 0, width, height);
  
  colorMode(HSB);
   
  // perform a forward FFT on the samples in jingle's mix buffer
  // note that if jingle were a MONO file, this would be the same as using jingle.left or jingle.right
  fftLin.forward( jingle.mix );
 
  // draw the full spectrum
    noFill();
    for(int i = 0; i < fftLin.specSize() / 1.5; i++) {
      radiusTarget[i] = fftLin.getBand(i) * spectrumScale;
      
//    line(i, height3, i, height3 - fftLin.getBand(i)*spectrumScale);
    }
    
    for(int i = 0; i < jingle.bufferSize() - 1; i++) {
      volume = jingle.left.level();
//      println(volume);

      if(volume > 0.1) {
        lumTarget = volume * 10;
      }
      else {
        lumTarget = 0;
      }
      
    }
//   rotate(PI);
    for(int i = 0; i < radiusTarget.length; i++) {
      /*
      if(radius[i] < 1000)
      {
        float t = map(i, 0, radiusTarget.length, 0, (-displayWidth) / 2);
      }
      else if(radius[i] < 500)
      {
        float t = map(i, 0, radiusTarget.length, 0, (-displayWidth) / 2);
      }
      else
      {
        float t = map(i, 0, radiusTarget.length, 0, (-displayWidth) / 2);
      }
      */
      
      radius[i] += (radiusTarget[i] - radius[i]) * 0.9;
      
      lum += (lumTarget - lum) * 0.1;

      float c = map(i, 0, radiusTarget.length + 100, 0, 255);
            
      stroke( c, 255, 255 );    

      shapeNumber = round(abs(volume * 100));
      
      

      if(radius[i] < displayHeight * 1.5)
      {
        if(radius[i] < displayHeight / 7) {
          strokeWeight( (lum + 1) % 2 );
          polygon( displayWidth / 2, displayHeight / 2, radius[i] * 2, shapeNumber % 12);
          rotate(frameRate / 100);
          translate(displayWidth / 2, displayWidth / 2);
        }
        else if(radius[i] < displayHeight / 4) {
          strokeWeight( (lum + 1) % 3 );
          polygon( displayWidth / 2, displayHeight / 2, radius[i] / 2, shapeNumber % 12);
          rotate(frameRate / 200);
          translate(displayWidth / 2, displayWidth / 2);
        }
        else if(radius[i] < displayHeight / 3) {
          strokeWeight( (lum + 1) % 3 );
          polygon( displayWidth / 2, displayHeight / 2, radius[i] / 5, shapeNumber % 12);
          rotate(frameRate / 200);
          translate(displayWidth / 2, displayWidth / 2);
        }
        else {
          strokeWeight( (lum + 1) % 2 );
          polygon( displayWidth / 2, displayHeight / 2, radius[i] / 10, shapeNumber % 12);
          rotate(frameRate / 200);
          translate(displayWidth / 2, displayWidth / 2);
        }
      
    }  
      
         }
//      println(shapeNumber);

}

int shapeNumber;

void polygon(float x, float y, float radius, int npoints) {
  float angle = TWO_PI / npoints;
  beginShape();
  for (float a = 0; a < TWO_PI; a += angle) {
    float sx = x + cos(a) * radius;
    float sy = y + sin(a) * radius;
    vertex(sx, sy);
  }
  endShape(CLOSE);
}